var assert = require('assert');
var activeobject = require('../')

module.exports = {
  
  "Should create attribute accessible getters" : function() {
    var clazz = activeobject({
      attributeAccessible: ["a"]
    });
    
    var propertyDescriptor = Object.getOwnPropertyDescriptor(clazz.prototype, "a");

    assert.ok(propertyDescriptor.enumerable);
    assert.ok(propertyDescriptor.configurable);
    assert.equal(typeof propertyDescriptor, "object");
    assert.equal(typeof propertyDescriptor.get, "function");
    assert.equal(typeof propertyDescriptor.set, "function");
  },
  
  "Should set attribute accessible value" : function() {
    var model = activeobject({
      attributeAccessible: ["a"]
    });
    
    var instance = new model();
    
    assert.equal(instance.a, undefined);
    instance.a = "foo";
    assert.equal(instance.a, "foo");
  }
  
};